/* import tr-069.h generated by wsdl2h */
#import "tr-069.h"

/** TR-069 SOAP headers */
struct SOAP_ENV__Header
{
  struct _cwmp__SupportedCWMPVersions *cwmp__SupportedCWMPVersions;
  struct _cwmp__UseCWMPVersion        *cwmp__UseCWMPVersion;
  struct _cwmp__SessionTimeout        *cwmp__SessionTimeout;
  struct _cwmp__ID                    *cwmp__ID;
  struct _cwmp__HoldRequests          *cwmp__HoldRequests;
};

/** TR-069 SOAP fault details */
struct SOAP_ENV__Detail
{
  struct _cwmp__Fault *cwmp__Fault;
  _XML                 __any;
};

/* TR-069 common operations */

//gsoap cwmp service name:     cwmp
//gsoap cwmp service style:    rpc
//gsoap cwmp service encoding: encoded

//gsoap cwmp service method-fault: GetParameterNames cwmp__Fault
/** GetParameterNames: Retrieve list of supported parameters from the device. */
int __cwmp__GetParameterNames(
    struct _cwmp__GetParameterNames         *cwmp__GetParameterNames,
    struct _cwmp__GetParameterNamesResponse *cwmp__GetParameterNamesResponse);

//gsoap cwmp service method-fault: GetParameterValues cwmp__Fault
/** GetParameterValues: Retrieve current value of the parameter(s) identified by keys. A variation of this call takes an object as its key. It retrieves all of the object's parameters */
int __cwmp__GetParameterValues(
    struct _cwmp__GetParameterValues         *cwmp__GetParameterValues,
    struct _cwmp__GetParameterValuesResponse *cwmp__GetParameterValuesResponse);

//gsoap cwmp service method-fault: GetParameterValuesResponse cwmp__Fault
/** GetParameterValuesResponse: Send current value of the parameter(s) identified by keys. This is a SOAP one-way message invoked as soap_send___cwmp__GetParameterValuesResponse() followed by soap_recv_empty_response() to check the server's response that should be a HTTP 204 status code */
int __cwmp__GetParameterValuesResponse(
    struct _cwmp__GetParameterValuesResponse *cwmp__GetParameterValuesResponse,
    void);

//gsoap cwmp service method-input-header-part: SetParameterValues cwmp__ID
//gsoap cwmp service method-fault: SetParameterValues cwmp__Fault
/** SetParameterValues: Set the value of one or more parameters */
int __cwmp__SetParameterValues(
    struct _cwmp__SetParameterValues         *cwmp__SetParameterValues,
    struct _cwmp__SetParameterValuesResponse *cwmp__SetParameterValuesResponse);

//gsoap cwmp service method-fault: GetParameterAttributes cwmp__Fault
/** GetParameterAttributes: Retrieve attributes of one or more parameters */
int __cwmp__GetParameterAttributes(
    struct _cwmp__GetParameterAttributes         *cwmp__GetParameterAttributes,
    struct _cwmp__GetParameterAttributesResponse *cwmp__GetParameterAttributesResponse);

//gsoap cwmp service method-fault: SetParameterAttributes cwmp__Fault
/** SetParameterAttributes: Set attributes of one or more parameters */
int __cwmp__SetParameterAttributes(
    struct _cwmp__SetParameterAttributes         *cwmp__SetParameterAttributes,
    struct _cwmp__SetParameterAttributesResponse *cwmp__SetParameterAttributesResponse);

//gsoap cwmp service method-fault: Download cwmp__Fault
/** Download: Order CPE to download and use a file, specified by URL. File types include Firmware Image, Configuration File, Ringer file, etc. */
int __cwmp__Download(
    struct _cwmp__Download         *cwmp__Download,
    struct _cwmp__DownloadResponse *cwmp__DownloadResponse);

//gsoap cwmp service method-fault: Upload cwmp__Fault
/** Upload: Order CPE to upload a file to a specified destination. File types include the current configuration file, log files, etc. */
int __cwmp__Upload(
    struct _cwmp__Upload         *cwmp__Upload,
    struct _cwmp__UploadResponse *cwmp__UploadResponse);

//gsoap cwmp service method-fault: AddObject cwmp__Fault
/** AddObject: Add new instance to an object */
int __cwmp__AddObject(
    struct _cwmp__AddObject         *cwmp__AddObject,
    struct _cwmp__AddObjectResponse *cwmp__AddObjectResponse);

//gsoap cwmp service method-fault: DeleteObject cwmp__Fault
/** DeleteObject: Remove instance from an object */
int __cwmp__DeleteObject(
    struct _cwmp__DeleteObject         *cwmp__DeleteObject,
    struct _cwmp__DeleteObjectResponse *cwmp__DeleteObjectResponse);

//gsoap cwmp service method-fault: GetRPCMethods cwmp__Fault
/** _cwmp__GetRPCMethods: Annex A.3.1.1 */
int __cwmp__GetRPCMethods(
    struct _cwmp__GetRPCMethods         *cwmp__GetRPCMethods,
    struct _cwmp__GetRPCMethodsResponse *cwmp__GetRPCMethodsResponse);

//gsoap cwmp service method-fault: Inform cwmp__Fault
/** Inform: Send Scheduled Inform to ACS*/
int __cwmp__Inform(
    struct _cwmp__Inform	*cwmp__Inform,
    struct _cwmp__InformResponse *cwmp__InformResponse);

int __cwmp__Reboot(
        struct _cwmp__Reboot	*cwmp__Reboot,
        struct _cwmp__RebootResponse *cwmp__RebootResponse);

int __cwmp__FactoryReset(
        struct _cwmp__FactoryReset	*cwmp__FactoryReset,
        struct _cwmp__FactoryResetResponse *cwmp__FactoryResetResponse);
